//---------------------------------------------------------------------------

#ifndef JobH
#define JobH
//---------------------------------------------------------------------------

#include <Classes.hpp>
#include <SysUtils.hpp>
#include <vector>

#include "ResizeCfg.h"

struct SourceFile;

class Job
{
public:
	enum Type
	{
		INVALID = 0,
		UNPACK,
		RENDER_PDF,
		CONVERT
	} type;
	AnsiString fileName;
	AnsiString tmpDir;
	AnsiString rootDir;
	ResizeCfg resizeCfg;
	AnsiString sImExtraParamsBeforeResize;
	AnsiString sImExtraParams;
	AnsiString sOutputExtension;

	void Execute(bool *abort, int priority);

	static void SetTmpPath(AnsiString dir);
	static void SetOutPath(AnsiString dir);
	static void SetUseSourceDirectoryForOutput(bool val);
	static void SetRecreateSourceDirectoryForOutput(bool val);
	static void SetGsPath(AnsiString gsExecutable);
	static void SetGsParams(AnsiString params);
	static void SetGsFilePattern(AnsiString pattern);

	static AnsiString GetOutPath(void);
	static AnsiString GetTmpPath(void);

	SourceFile *file;
	Job(SourceFile *file);
	const char* GetTypeName(void) const;

private:
	void Unpack(void);
	void RenderPdf(void);
	void Convert(void);
	void ConvertFile(AnsiString name, int width, int height);
	void Pack(void);

	void ProcessSource(AnsiString dir, AnsiString cmdline);


	bool* abort;
};

#endif
